
function Demo()
{
	var self = this;
	
	var OBJECTS_TYPES = {
		ANALOG_INPUT: 0, 
		ANALOG_OUTPUT: 1, 
		ANALOG_VALUE: 2, 
		BINARY_INPUT: 3, 
		BINARY_OUTPUT: 4, 
		BINARY_VALUE: 5, 
		MULTI_STATE_INPUT: 13, 
		MULTI_STATE_OUTPUT: 14, 
		MULTI_STATE_VALUE: 19
	};
	
	var PROPERTY_IDENTIFIERS = {
		PRESENT_VALUE: 85
	};
	
	
	var demoDeviceID = 10103;

	
	function initialize()
	{
		
	}
	
	this.refresh = function() 
	{
		JSInterface.whoIs();
	}
	
	this.analog_object_sidder = function() 
	{	
		if ((typeof this.timeout !== "undefined") && (this.timeout != null)) 
		{
			clearTimeout(this.timeout);
		}
		
		this.timeout = setTimeout(function() {			
			JSInterface.writeDeviceObjectProperty(demoDeviceID, 
													OBJECTS_TYPES.ANALOG_OUTPUT, 
													0, 
													PROPERTY_IDENTIFIERS.PRESENT_VALUE, 
													-1, 
													8, 
													parseFloat($('#slider1').val()), 
													false);
									}, 1000);
	}
	
	this.binary_object_switch = function()
	{	
		var val = $('input[name="radio-choice-a1"]:checked').val();
		
		JSInterface.writeDeviceObjectProperty(demoDeviceID, 
												OBJECTS_TYPES.BINARY_VALUE, 
												0, 
												PROPERTY_IDENTIFIERS.PRESENT_VALUE, 
												-1, 
												8, 
												parseFloat(val), 
												false);
	}
	
	this.binary_object_flip_toggle = function()
	{
		if ((typeof this.timeout !== "undefined") && (this.timeout != null)) 
		{
			clearTimeout(this.timeout);
		}
		
		this.timeout = setTimeout(function() {	
			var val = $('#flip-1').val();
			
			JSInterface.writeDeviceObjectProperty(demoDeviceID, 
													OBJECTS_TYPES.BINARY_VALUE, 
													0, 
													PROPERTY_IDENTIFIERS.PRESENT_VALUE, 
													-1, 
													8, 
													parseFloat(val), 
													false);
									}, 300);
	}
	
	this.multistate_object_select = function()
	{
		var val = $('#select-1').val();
		
		JSInterface.writeDeviceObjectProperty(demoDeviceID, 
												OBJECTS_TYPES.MULTI_STATE_VALUE, 
												0, 
												PROPERTY_IDENTIFIERS.PRESENT_VALUE, 
												-1, 
												8, 
												parseFloat(val), 
												false);
	}
	
	this.multistate_object_radio = function()
	{
		var val = $('input[name="radio-choice-h-1"]:checked').val();
		
		JSInterface.writeDeviceObjectProperty(demoDeviceID, 
												OBJECTS_TYPES.MULTI_STATE_VALUE, 
												0, 
												PROPERTY_IDENTIFIERS.PRESENT_VALUE, 
												-1, 
												8, 
												parseFloat(val), 
												false);
	}
	
	this.show_platform_message = function()
	{
		JSInterface.platformNotificationAlert("title", "Demo Message.", "OK", true, "info");
	}
	
	this.read_object_property = function()
	{
		JSInterface.readDeviceObjectProperty(demoDeviceID, 
												OBJECTS_TYPES.BINARY_VALUE, 
												0, 
												PROPERTY_IDENTIFIERS.PRESENT_VALUE, 
												-1);
	}
	
	initialize();
}


JSInterface.updateDevice = function(deviceID, deviceName, segmentation, 
									vendorID, modelName)
{
	var str;
	
	str = "updateDevice\n" + 
			"deviceID: " + deviceID + "\n" + 
			"deviceName: " + deviceName + "\n" + 
			"segmentation: " + segmentation + "\n" + 
			"vendorID: " + vendorID + "\n" + 
			"modelName: " + modelName;
	
	JSInterface.platformNotificationAlert("updateDevice", str, "OK", true, "info");
}

JSInterface.readDeviceObjectPropertyAck = function(deviceID, objectType, objectInstance, 
													propertyIdentifier,	arrayIndex, value)
{
	var str;
	
	str = "readDeviceObjectPropertyAck\n" + 
			"deviceID: " + deviceID + "\n" + 
			"objectType: " + objectType + "\n" + 
			"objectInstance: " + objectInstance + "\n" + 
			"propertyIdentifier: " + propertyIdentifier + "\n" + 
			"arrayIndex: " + arrayIndex + "\n" + 
			"value: " + value;
	
	JSInterface.platformNotificationAlert("readDeviceObjectPropertyAck", str, "OK", true, "info");
}

JSInterface.writeDeviceObjectPropertyAck = function(deviceID, objectType, objectInstance, 
													propertyIdentifier, arrayIndex)
{
	var str;
	
	str = "writeDeviceObjectPropertyAck\n" + 
			"deviceID: " + deviceID + "\n" + 
			"objectType: " + objectType + "\n" + 
			"objectInstance: " + objectInstance + "\n" + 
			"propertyIdentifier: " + propertyIdentifier + "\n" + 
			"arrayIndex: " + arrayIndex;
	
	JSInterface.platformNotificationAlert("writeDeviceObjectPropertyAck", str, "OK", true, "info");
}

JSInterface.writeDeviceObjectPropertyError = function(deviceID, objectType, objectInstance,
														propertyIdentifier, arrayIndex, errorClass,
														errorClassText, errorCode, errorCodeText)
{
	var str;
	
	str = "writeDeviceObjectPropertyError\n" + 
			"deviceID: " + deviceID + "\n" + 
			"objectType: " + objectType + "\n" + 
			"objectInstance: " + objectInstance + "\n" + 
			"propertyIdentifier: " + propertyIdentifier + "\n" + 
			"arrayIndex: " + arrayIndex + "\n" + 
			"errorClass: " + errorClass + "\n" + 
			"errorClassText: " + errorClassText + "\n" + 
			"errorCode: " + errorCode + "\n" + 
			"errorCodeText: " + errorCodeText;
	
	JSInterface.platformNotificationAlert("writeDeviceObjectPropertyError", str, "OK", true, "info");
}
